use std::{collections::HashMap, hash::Hash};

use crate::runbase::{read_lines, RunBase};

pub struct One {
    lines: Vec<(i32, i32)>,
}

impl RunBase<One> for One {
    fn new() -> One {
        return One {
            lines: read_lines("inputs/1")
                .into_iter()
                .map(|x| {
                    let mut temp = x.split("   ");
                    return (
                        temp.next().unwrap().parse().unwrap(),
                        temp.next().unwrap().parse().unwrap(),
                    );
                })
                .collect(),
        };
    }

    fn run(&self) {
        self.run_1();
        self.run_2();
    }
    
    fn run_1(&self) {
        let mut left_list: Vec<_> = self.lines.iter().map(|x| x.0).collect();
        let mut right_list: Vec<_> = self.lines.iter().map(|x| x.1).collect();
        left_list.sort();
        right_list.sort();
        let res = left_list
            .into_iter()
            .enumerate()
            .fold(0, |collect: i32, (i, x)| {
                collect + (x - right_list.get(i).unwrap()).abs()
            });
        println!("{}", res);
    }
    
    fn run_2(&self) {
        let mut left_list: Vec<_> = self.lines.iter().map(|x| x.0).collect();
        let mut right_list: Vec<_> = self.lines.iter().map(|x| x.1).collect();
        let mut map:HashMap<i32, i32> = HashMap::new();

        for left in &left_list{
            map.insert(*left, 0);
        }

        for right in right_list {
            if map.contains_key(&right) {
                *map.get_mut(&right).unwrap() += 1;
            }
        }
        
        let sum = left_list.into_iter().fold(0, |acc,x| acc + (x * map.get(&x).unwrap()) );
        println!("{}", sum);
    }
}
