use std::fs;


pub fn read_lines(file: &str) -> Vec<String>{
    match fs::read_to_string(file){
        Ok(x) => {
            return x.split("\n").map(|x| x.to_string()).collect::<Vec<String>>()
        },
        Err(_) => {
            panic!("Could not read input file");
            
        }
    };
}

pub trait RunBase<T> {
    fn new() -> T;
    fn run(&self);
    fn run_1(&self);
    fn run_2(&self);
}